> This is a page from the ElevenLabs documentation. For a complete page index, fetch https://elevenlabs.io/docs/llms.txt. For the full documentation in a single file, fetch https://elevenlabs.io/docs/llms-full.txt. # Update phone number PATCH https://api.elevenlabs.io/v1/convai/phone-numbers/{phone_number_id} Content-Type: application/json Update assigned agent of a phone number Reference: https://elevenlabs.io/docs/eleven-agents/api-reference/phone-numbers/update ## Servers - `https://api.elevenlabs.io` (Production, default) - `https://api.us.elevenlabs.io` (Production US) - `https://api.eu.residency.elevenlabs.io` (Production EU) - `https://api.in.residency.elevenlabs.io` (Production India) - `https://api.sg.residency.elevenlabs.io` (Production Singapore) ## Request ### Path parameters - `phone_number_id` (string, required) — The phone number ID. This is returned when a phone number is imported. ### Body (application/json) This endpoint expects an object. - `agent_id` (string, optional) - `label` (string, optional) - `inbound_trunk_config` (InboundSipTrunkConfigRequestModel, optional) - `outbound_trunk_config` (OutboundSipTrunkConfigRequestModel, optional) - `livekit_stack` (enum, optional, default: standard) - Allowed values: `standard`, `static` - `store_sip_messages` (boolean, optional) - `environment` (string, optional) — Environment to use for resolving environment variables on calls to this number. - `branch_id` (string, optional) — Agent branch to use for calls to this number. ## Response ### 200 Successful Response - `PhoneNumbersUpdateResponse` - `provider`: `twilio` - `label` (string, required) — Label for the phone number - `phone_number` (string, required) — Phone number - `phone_number_id` (string, required) — The ID of the phone number - `assigned_agent` (PhoneNumberAgentInfo, optional) — The agent that is assigned to the phone number - `supports_inbound` (boolean, optional, default: true, deprecated) — This field is deprecated and will be removed in the future. Whether this phone number supports inbound calls - `supports_outbound` (boolean, optional, default: true, deprecated) — This field is deprecated and will be removed in the future. Whether this phone number supports outbound calls - `provider`: `exotel` - `label` (string, required) — Label for the phone number - `phone_number` (string, required) — Phone number - `phone_number_id` (string, required) — The ID of the phone number - `assigned_agent` (PhoneNumberAgentInfo, optional) — The agent that is assigned to the phone number - `supports_inbound` (boolean, optional, default: true, deprecated) — This field is deprecated and will be removed in the future. Whether this phone number supports inbound calls - `supports_outbound` (boolean, optional, default: true, deprecated) — This field is deprecated and will be removed in the future. Whether this phone number supports outbound calls - `provider`: `sip_trunk` - `label` (string, required) — Label for the phone number - `livekit_stack` (enum, required, default: standard) — Type of Livekit stack used for this number. - Allowed values: `standard`, `static` - `phone_number` (string, required) — Phone number - `phone_number_id` (string, required) — The ID of the phone number - `assigned_agent` (PhoneNumberAgentInfo, optional) — The agent that is assigned to the phone number - `inbound_trunk` (GetPhoneNumberInboundSipTrunkConfigResponseModel, optional) — Configuration of the Inbound SIP trunk - if configured. - `outbound_trunk` (GetPhoneNumberOutboundSipTrunkConfigResponseModel, optional) — Configuration of the Outbound SIP trunk - if configured. - `store_sip_messages` (boolean, optional, default: true) — Whether to store SIP messages for this phone number. - `provider_config` (GetPhoneNumberOutboundSipTrunkConfigResponseModel, optional, deprecated) — SIP Trunk configuration details for a phone number - `supports_inbound` (boolean, optional, default: true, deprecated) — This field is deprecated and will be removed in the future. Whether this phone number supports inbound calls - `supports_outbound` (boolean, optional, default: true, deprecated) — This field is deprecated and will be removed in the future. Whether this phone number supports outbound calls ## Errors ### 422 Phone Numbers Update Request Unprocessable Entity Error Validation Error - `detail` (list of ValidationError, optional) ## Types ### InboundSipTrunkConfigRequestModel - `allowed_addresses` (list of string, optional) — List of IP addresses that are allowed to use the trunk. Each item in the list can be an individual IP address or a Classless Inter-Domain Routing notation representing a CIDR block. - `allowed_numbers` (list of string, optional) — List of phone numbers that are allowed to use the trunk. - `media_encryption` (enum, optional, default: allowed) — Whether or not to encrypt media (data layer). - Allowed values: `disabled`, `allowed`, `required` - `credentials` (SipTrunkCredentialsRequestModel, optional) — Optional digest authentication credentials (username/password). - `remote_domains` (list of string, optional) — Domains of remote SIP servers used to validate TLS certificates. - `attributes_to_headers` (map from string to string, optional) — Map of dynamic variable name to header name for attributes_to_headers ### OutboundSipTrunkConfigRequestModel - `address` (string, required) — Hostname or IP the SIP INVITE is sent to. - `transport` (enum, optional, default: auto) — Protocol to use for SIP transport (signalling layer). - Allowed values: `auto`, `udp`, `tcp`, `tls` - `media_encryption` (enum, optional, default: allowed) — Whether or not to encrypt media (data layer). - Allowed values: `disabled`, `allowed`, `required` - `headers` (map from string to string, optional) — SIP X-* headers for INVITE request. These headers are sent as-is and may help identify this call. - `attributes_to_headers` (map from string to string, optional) — Map of dynamic variable name to header name for attributes_to_headers - `credentials` (SipTrunkCredentialsRequestModel, optional) — Optional digest authentication credentials (username/password). If not provided, ACL authentication is assumed. - `enabled_codecs` (list of enum, optional) — Media codecs that should be offered in the SDP for outbound calls. If empty, all supported codecs are offered. - Allowed values: `G722/8000`, `PCMU/8000`, `PCMA/8000` ### PhoneNumberAgentInfo - `agent_id` (string, required) — The ID of the agent - `agent_name` (string, required) — The name of the agent - `environment` (string, optional) — Environment to use for resolving environment variables on calls to this number. - `branch_id` (string, optional) — Agent branch to use for calls to this number. ### GetPhoneNumberInboundSipTrunkConfigResponseModel - `allowed_addresses` (list of string, required) — List of IP addresses that are allowed to use the trunk. Each item in the list can be an individual IP address or a Classless Inter-Domain Routing notation representing a CIDR block. - `media_encryption` (enum, required, default: allowed) - Allowed values: `disabled`, `allowed`, `required` - `has_auth_credentials` (boolean, required) — Whether authentication credentials are configured - `allowed_numbers` (list of string, optional) — List of phone numbers that are allowed to use the trunk. - `username` (string, optional) — SIP trunk username (if available) - `remote_domains` (list of string, optional) — Domains of remote SIP servers used to validate TLS certificates. - `attributes_to_headers` (map from string to string, optional) — Map of dynamic variable name to header name for attributes_to_headers ### GetPhoneNumberOutboundSipTrunkConfigResponseModel SIP Trunk configuration details for a phone number - `address` (string, required) — Hostname or IP the SIP INVITE is sent to - `transport` (enum, required, default: auto) — Protocol to use for SIP transport - Allowed values: `auto`, `udp`, `tcp`, `tls` - `media_encryption` (enum, required, default: allowed) — Whether or not to encrypt media (data layer). - Allowed values: `disabled`, `allowed`, `required` - `has_auth_credentials` (boolean, required) — Whether authentication credentials are configured - `headers` (map from string to string, optional) — SIP headers for INVITE request - `attributes_to_headers` (map from string to string, optional) — Map of dynamic variable name to header name for attributes_to_headers - `username` (string, optional) — SIP trunk username (if available) - `has_outbound_trunk` (boolean, optional, default: false) — Whether a LiveKit SIP outbound trunk is configured - `enabled_codecs` (list of enum, optional) — Media codecs that are offered in the SDP for outbound calls. If empty, all supported codecs are offered. - Allowed values: `G722/8000`, `PCMU/8000`, `PCMA/8000` ### ValidationError - `loc` (list of ValidationErrorLocItem, required) - `msg` (string, required) - `type` (string, required) ### SipTrunkCredentialsRequestModel - `username` (string, required) — SIP trunk username - `password` (string, optional) — SIP trunk password - if not specified, then remain unchanged ### ValidationErrorLocItem ## Examples **Request** ```json {} ``` **Response** ```json { "provider": "twilio", "label": "Customer Support", "phone_number": "+1234567890", "phone_number_id": "phone_123", "assigned_agent": { "agent_id": "F3Pbu5gP6NNKBscdCdwB", "agent_name": "My Agent", "environment": "environment", "branch_id": "branch_id" } } ``` **SDK Code** ```python import requests url = "https://api.elevenlabs.io/v1/convai/phone-numbers/TeaqRRdTcIfIu2i7BYfT" payload = {} headers = {"Content-Type": "application/json"} response = requests.patch(url, json=payload, headers=headers) print(response.json()) ``` ```javascript const url = 'https://api.elevenlabs.io/v1/convai/phone-numbers/TeaqRRdTcIfIu2i7BYfT'; const options = {method: 'PATCH', headers: {'Content-Type': 'application/json'}, body: '{}'}; try { const response = await fetch(url, options); const data = await response.json(); console.log(data); } catch (error) { console.error(error); } ``` ```go package main import ( "fmt" "strings" "net/http" "io" ) func main() { url := "https://api.elevenlabs.io/v1/convai/phone-numbers/TeaqRRdTcIfIu2i7BYfT" payload := strings.NewReader("{}") req, _ := http.NewRequest("PATCH", url, payload) req.Header.Add("Content-Type", "application/json") res, _ := http.DefaultClient.Do(req) defer res.Body.Close() body, _ := io.ReadAll(res.Body) fmt.Println(res) fmt.Println(string(body)) } ``` ```ruby require 'uri' require 'net/http' url = URI("https://api.elevenlabs.io/v1/convai/phone-numbers/TeaqRRdTcIfIu2i7BYfT") http = Net::HTTP.new(url.host, url.port) http.use_ssl = true request = Net::HTTP::Patch.new(url) request["Content-Type"] = 'application/json' request.body = "{}" response = http.request(request) puts response.read_body ``` ```java import com.mashape.unirest.http.HttpResponse; import com.mashape.unirest.http.Unirest; HttpResponse response = Unirest.patch("https://api.elevenlabs.io/v1/convai/phone-numbers/TeaqRRdTcIfIu2i7BYfT") .header("Content-Type", "application/json") .body("{}") .asString(); ``` ```php request('PATCH', 'https://api.elevenlabs.io/v1/convai/phone-numbers/TeaqRRdTcIfIu2i7BYfT', [ 'body' => '{}', 'headers' => [ 'Content-Type' => 'application/json', ], ]); echo $response->getBody(); ``` ```csharp using RestSharp; var client = new RestClient("https://api.elevenlabs.io/v1/convai/phone-numbers/TeaqRRdTcIfIu2i7BYfT"); var request = new RestRequest(Method.PATCH); request.AddHeader("Content-Type", "application/json"); request.AddParameter("application/json", "{}", ParameterType.RequestBody); IRestResponse response = client.Execute(request); ``` ```swift import Foundation let headers = ["Content-Type": "application/json"] let parameters = [] as [String : Any] let postData = JSONSerialization.data(withJSONObject: parameters, options: []) let request = NSMutableURLRequest(url: NSURL(string: "https://api.elevenlabs.io/v1/convai/phone-numbers/TeaqRRdTcIfIu2i7BYfT")! as URL, cachePolicy: .useProtocolCachePolicy, timeoutInterval: 10.0) request.httpMethod = "PATCH" request.allHTTPHeaderFields = headers request.httpBody = postData as Data let session = URLSession.shared let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in if (error != nil) { print(error as Any) } else { let httpResponse = response as? HTTPURLResponse print(httpResponse) } }) dataTask.resume() ``` > ElevenLabs provides APIs and SDKs for text to speech, voice cloning, speech to text, sound effects, voice isolator, voice changer, and conversational AI agents. Build voice-enabled applications with lifelike audio generation.